﻿
// cEIP MotionControl ExampleDlg.h: 헤더 파일
//

#pragma once


// CcEIPMotionControlExampleDlg 대화 상자
class CcEIPMotionControlExampleDlg : public CDialogEx
{
// 생성입니다.
public:
	CcEIPMotionControlExampleDlg(CWnd* pParent = nullptr);	// 표준 생성자입니다.

// 대화 상자 데이터입니다.
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_CEIP_MOTIONCONTROL_EXAMPLE_DIALOG };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 지원입니다.


// 구현입니다.
protected:
	HICON m_hIcon;

	// 생성된 메시지 맵 함수
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnBnClickedInit();
	CComboBox CB_Control_Axis;
	CComboBox CB_AlarmLogic;
	CComboBox CB_AlarmStop;
	CComboBox CB_EL_Logic;
	CComboBox CB_EL_Stop;
	CComboBox CB_ORGLogic;
	CComboBox CB_ServoInputLogic;
	CComboBox CB_EncoderFeedback;
	CComboBox CB_CommandPulseMode;
	CComboBox CB_SxSpeedMode;
	CComboBox CB_HomeMode;
	CComboBox CB_HomeSpeedMode;
	CComboBox CB_HomeDir;
	CStatic LB_CMD_Pos;
	CStatic LB_FB_Pos;
	CStatic LB_CMD_Spd;
	CStatic LB_FB_Spd;
	CStatic LB_MotState;
	CStatic PC_ALM;
	CStatic PC_NEL;
	CStatic PC_PEL;
	CStatic PC_ORG;
	CStatic PC_INP;
	CStatic PC_RDY;
	CStatic PC_LTC;
	CStatic PC_SD;
	CEdit TB_SxWorkSpeed;
	CEdit TB_InitSpeed;
	CEdit TB_SxAccel;
	CEdit TB_Decel;
	CEdit TB_AbsolutePos1;
	CEdit TB_AbsolutePos2;
	CEdit TB_RelativePos;
	CEdit TB_HomeSpeed;
	CEdit TB_HomeAccel;
	CEdit TB_HomeDecel;
	CEdit TB_HomeEzCount;
	CEdit TB_HomeOffset;
	CEdit TB_HomeReverseVel;
	CEdit TB_HomeEscapeDist;
	CButton RB_VelocityMode;
	CButton RB_AbsoluteMode;
	CButton RB_RelativeMode;
	CButton BT_SERVO_ONOFF;
	afx_msg void OnClose();

#pragma region UI관련
	void GUI_Init();
	void GUI_Refresh_All();
	void GUI_Refresh_ServoOnOff();
	void GUI_Refresh_Position();
	void GUI_Refresh_MotState();//MotState Refresh
	void GUI_Refresh_MIOState();//MIO Refresh
	void GUI_Refresh_Logic();//Logic Refresh
	void GUI_Refresh_SxSpeedSetup();//SxSpeedSetup Refresh
	void GUI_Refresh_HomeSetup();//HomeSetup Refresh
	void GUI_Refresh_DIO();//DIO Refresh

	void GUI_SetControlAxisInfo();
	void GUI_SetLedState(CStatic* nLedId, int nLedState);

#pragma endregion

#pragma region Init관련
	void Init_cEIP();
	bool Init_cEIPConnectionCheck();
	void End_cEIP();
#pragma endregion

#pragma region Control관련
	void CTRL_Toggle_ServoOn();//서보 온 신호 토글
	void CTRL_Pos_Reset();//포지션 리셋
	void CTRL_Alarm_Reset();//알람 리셋
	void CTRL_Apply_MIOLogic();//로직 적용
	void CTRL_Apply_SxSetup();//스피드패턴 적용
	void CTRL_Apply_HomeSetup();//스피드패턴 적용
	void CTRL_VMove(long dir);//속도이송
	void CTRL_Relative_Move(long dir);//상대이송
	void CTRL_Absolute_Move(long dir);//절대이송
	void CTRL_Homming();//원점복귀
	void CTRL_Stop(); //정지
	void CTRL_EMGStop(); //급정지
#pragma endregion

	
	afx_msg void OnBnClickedBtServoOnoff();
	afx_msg void OnBnClickedResetpos();
	afx_msg void OnBnClickedResetalarm();
	afx_msg void OnBnClickedApplyLogic();
	afx_msg void OnBnClickedApplySpeed();
	afx_msg void OnBnClickedSxmoveN();
	afx_msg void OnBnClickedSxmoveP();
	afx_msg void OnBnClickedSxstop();
	afx_msg void OnBnClickedSxemgstop();
	afx_msg void OnBnClickedSxstop2();
	afx_msg void OnBnClickedSxemgstop2();
	afx_msg void OnBnClickedApplyHome();
	afx_msg void OnBnClickedHomemove();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnCbnSelchangeCbAxis();
	afx_msg void DIDO_OFF();
	afx_msg void OnBnClickedButton1();
	afx_msg void DIDO_ON();
	afx_msg void OnBnClickedOn();
	afx_msg void OnStnClickedPcAlm();

	CButton check2;
	CButton check0;
	CButton check1;
	CButton check3;
	CButton check4;
	CButton check5;
	CButton check6;
	CButton check7;
	CButton check8;
	CButton check9;
	CButton check10;
	CButton check11;
	CButton check12;
	CButton check13;
	CButton check14;
	CButton check15;
	afx_msg void OnCbnSelchangeCbAlarmlogic();
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickLogic_A();
	afx_msg void OnBnClickLogic_B();

	afx_msg void OnBnClickedA();
	afx_msg void OnBnClickedB();
	CButton ALM_check;
	CButton ELminus_check;
	CButton ELplus_check;
	CButton ORG_check;
	CButton INP_check;
	CButton RDY_check;
	CButton LTC_check;
	CButton SD_check;
};
